use `ombutel`;

-- remove first constraint if exists
select if(count(1), 'alter table `ombu_application_users` drop foreign key `ombu_application_users_ibfk_1`','set @dummy = ''''')
into @stmt from `information_schema`.`table_constraints`
where `table_schema` = 'ombutel' and `constraint_name` = 'ombu_application_users_ibfk_1';
prepare stmt from @stmt;
execute stmt;

-- remove second constraint if exists
select if(count(1), 'alter table `ombu_application_users` drop foreign key `ombu_application_users_ibfk_2`','set @dummy = ''''')
into @stmt from `information_schema`.`table_constraints`
where `table_schema` = 'ombutel' and `constraint_name` = 'ombu_application_users_ibfk_2';
prepare stmt from @stmt;
execute stmt;

-- delete invalid references
delete au from `ombu_application_users` au
left join `ombu_users` u on (u.`user_id` = au.`user_id`)
where u.`user_id` is null;

-- add first constraint
alter table `ombu_application_users`
add constraint `ombu_application_users_ibfk_1`
foreign key (`application_id`)
references `ombu_applications` (`application_id`) on delete cascade;

-- add second constraint
alter table `ombu_application_users`
add constraint `ombu_application_users_ibfk_2`
foreign key (`user_id`)
references `ombu_users` (`user_id`) on delete cascade;
