(() => {
	const log_interval = 2000;

	function refresh_update_log() {
		$.ajax("/", { data: { "class": "updates", method: "update_progress" }, success: (response) => {
			try {
				response = JSON.parse(response);
				const log = $("#updatesgeneral .log-container textarea").val(response.log).get(0);
				if (log.scrollTop == 0) {
					log.scrollTop = log.scrollHeight; // scroll to bottom unless user has been scrolling
				}
				if (response.done) {
					$("#updatesgeneral button.update-system").prop("disabled", false);
				} else {
					setTimeout(refresh_update_log, log_interval);
				}
			} catch(err) {
				setTimeout(refresh_update_log, log_interval);
			}
		}, error: () => {
			setTimeout(refresh_update_log, log_interval);
		}});
	}

	$("#updatesgeneral button.update-system").click((event) => {
		event.preventDefault();
		$("#updatesgeneral button.update-system").prop("disabled", true);
		$("#updatesgeneral .log-container").empty().append($("<textarea>"));
		pbx_request("updates", "update_system").then(refresh_update_log);
		return false;
	});

	$("#updatesgeneral button.no-updates").click((event) => {
		event.preventDefault();
		return false;
	});

	$("#updatesgeneral button.activate-agreement").click((event) => {
		event.preventDefault();
		$("#updatesgeneral button.activate-agreement").prop("disabled", true);
		pbx_request("updates", "activate_agreement").then((response) => {
			if (response.activated) {
				pbx_request("updates", "getContent");
			}
			$("#updatesgeneral button.activate-agreement").prop("disabled", false);
		});
		return false;
	});

	pbx_request("updates", "latest_cpbx_version").then((response) => {
		$("#updatesgeneral .form-group-latest_version .form-control-static").text(response.version);
	});
})();
